unit MainUnit;

interface

uses
  Windows, SysUtils, StdCtrls, Forms, Classes, Controls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses SimpsonMethod;

{$R *.dfm}

function F(const x: Extended): Extended;
begin
  Result := 4.0*x*x*x;
  //12.0*x*x*x*x*x*x*x*x*x*x*x;
end;

procedure F_InProc(const x: Double; out f: Double);
begin
  f := 4.0*x*x*x;
  //12.0*x*x*x*x*x*x*x*x*x*x*x;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  t1, t2 : Dword;
  ResInt : Extended;       
  ResIntDouble : Double;
  I : Integer;
begin
  t1 := GetTickCount;
     ResInt := Simpson(F,0,1,10000000);
  t2 := GetTickCount;
  Label1.Caption := 'ResInt1 = '
                    + FloatToStr(ResInt)
                    + ' (' + IntToStr(t2-t1)
                    + ' ms)';
  t1 := GetTickCount;
     for I := 1 to 100000 do ResInt := Simpson(F,0,1,1e-5);
  t2 := GetTickCount;
  Label2.Caption := 'ResInt2 = '
                    + FloatToStr(ResInt)
                    + ' (' + IntToStr(t2-t1)
                    + ' ms)';
  t1 := GetTickCount;
     ResIntDouble := Simpson(F_InProc,0,1,10000000);
  t2 := GetTickCount;
  Label3.Caption := 'ResIntDouble1 = '
                    + FloatToStr(ResIntDouble)
                    + ' (' + IntToStr(t2-t1)
                    + ' ms)';
  t1 := GetTickCount;
     for I := 1 to 100000 do ResIntDouble := Simpson(F_InProc,0,1,1e-5);
  t2 := GetTickCount;
  Label4.Caption := 'ResIntDouble2 = '
                    + FloatToStr(ResIntDouble)
                    + ' (' + IntToStr(t2-t1)
                    + ' ms)';
end;

end.
